#!/usr/bin/python

import string
import subprocess
import os

class backend:
    def __init__(self):
        self.plugin_list = []

    def shell_exec_remote(self, cmd):
        return_text = ''
        cmd=['sudo /usr/bin/ecm-remote ' + cmd]
        return_shell = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
        return_text = return_shell.stdout.readlines()
        return_shell.wait()
        if not return_shell.returncode == 0:
            return False
        return return_text

    def poll_userlist(self, users = None, groups = False, remote=None):
        text=[]
        cmd = ''
        if not groups == False:
            cmd = '-G '
        if users == None:
            cmd = cmd+'-U'
            text_return = self.shell_exec_remote(cmd)
            for user in text_return:
                text.append(user.rstrip().strip().split(','))
        else:
            if not type(users) == list:
                return False
            users = string.join(users,',')
            cmd = cmd+'-U -u '+users
            text_return = self.shell_exec_remote(cmd)
            for user in text_return:
                text.append(user.rstrip().strip().split(','))
        return text

    def poll_proclist(self, user = None, filter = None):
        cmd = ''
        if filter == None:
            cmd = '-p'
        else:
            if not type(filter) == list:
                return False
            cmd = '-p '+filter
        if user != None:
            if type(user) == list:
                user = string.join(user,',')
            elif not type(user) == str:
                return false
            cmd = cmd+' -u '+user
        if cmd == '':
            return False
        return self.shell_exec_remote(cmd)

    def kill_process(self, process, user = None, remote = None):
        if not type(process) == str:
            return false
        cmd = '-k '+process
        if user != None:
            if type(user) == list:
                user = string.join(user,',')
            elif not type(user) == str:
                return false
            cmd = cmd+' -u '+user
        return self.shell_exec_remote(cmd)

    def start_process(self, users, command, remote = None):
        if not type(command) == str:
            return false
        cmd = '-e "'+command+'"'
        if users != None:
            if type(users) == list:
                users = string.join(users,',')
            else:
                return False
            cmd = cmd+' -u '+users
        return self.shell_exec_remote(cmd)

    def logout_pid(self, pid, remote = None):
        if not type(pid) == str:
            return false
        cmd='-D '+pid
        return self.shell_exec_remote(cmd)

    def unlock(self, user, remote = None):
        if type(user) == list:
            user = string.join(user,',')
        elif not type(user) == str:
            return false
        cmd='-c -u '+user
        return self.shell_exec_remote(cmd)
    
    def lock(self, user, remote = None):
        if type(user) == list:
            user = string.join(user,',')
        elif not type(user) == str:
            return false
        cmd='-l -u '+user
        return self.shell_exec_remote(cmd)

    def send_message(self, user, message):
        if type(user) == list:
            user = string.join(user,',')
        elif not type(user) == str:
            return false
        message = message.replace("'", " ")
        cmd='-m "'+message+'" -u '+user
        return self.shell_exec_remote(cmd)

    def get_gnome_menu(self):
        cmd = '-M'
        return_text = self.shell_exec_remote(cmd)
        return eval(str(return_text[0]))

    def share(self, users, remote = None):
        from base64 import b64encode
        import random
        pidapp = os.getpid()
        # gen vnc passwd
        list_char=string.ascii_letters+string.digits
        passwd=""
        for i in range(8):
            passwd+=list_char[random.randint(0,len(list_char)-1)]
        passwdbase64=b64encode(passwd)
        # configure vino
        subprocess.Popen(['gconftool-2 --set /desktop/gnome/remote_access/enabled -t bool 1'], shell=True, stdout=subprocess.PIPE)
        subprocess.Popen(['gconftool-2 --set /desktop/gnome/remote_access/local_only -t bool 0'], shell=True, stdout=subprocess.PIPE)
        subprocess.Popen(['gconftool-2 --set /desktop/gnome/remote_access/authentication_methods -t list --list-type string "[vnc]"'], shell=True, stdout=subprocess.PIPE)
        subprocess.Popen(['gconftool-2 --set /desktop/gnome/remote_access/prompt_enabled -t bool 0'], shell=True, stdout=subprocess.PIPE)
        subprocess.Popen(['gconftool-2 --set /desktop/gnome/remote_access/vnc_password -t string "'+passwdbase64+'"'], shell=True, stdout=subprocess.PIPE)
        subprocess.Popen(['gconftool-2 --set /desktop/gnome/remote_access/icon_visibility -t string "client"'], shell=True, stdout=subprocess.PIPE)
        subprocess.Popen(['gconftool-2 --set /desktop/gnome/remote_access/view_only -t bool 1'], shell=True, stdout=subprocess.PIPE)

        # search port
        port_tmp=subprocess.Popen(["netstat -taupe --numeric-ports 2> /dev/null |grep LISTEN|grep vino-server |awk '{print $4}'|sed 's/://g'"], shell=True, stdout=subprocess.PIPE)
        port = port_tmp.stdout.read().rstrip().strip()
        if port == '':
            return False
        # manage passwdfile
        filepassname = '/tmp/passwd.'+str(pidapp)
        self.shell_exec_remote('-e "touch '+filepassname+'"')
        self.shell_exec_remote('-e "chmod 600 '+filepassname+'"')
        self.shell_exec_remote('-e "echo '+passwd+' > '+filepassname+'"')
        self.shell_exec_remote('-e "echo '+passwd+' >> '+filepassname+'"')
        filepassencnameuser = '.passwdenc'
        filepassencname = '/tmp/'+filepassencnameuser+'.'+str(pidapp)
        self.shell_exec_remote('-e "vncpasswd '+filepassencname+' < '+filepassname+' > /dev/null"')
        self.shell_exec_remote('-e "rm -rf '+filepassname+'"')

        # configure and start vncviewer
        for user in users:
            homeuser = self.poll_userlist([user])[0][4]
            if homeuser == False:
                return False
            self.shell_exec_remote('-e "cp '+filepassencname+' '+homeuser+'/'+filepassencnameuser+'"')
            self.shell_exec_remote('-e "chown '+user+' '+homeuser+'/'+filepassencnameuser+'"')
            cmd = '-e "/usr/bin/vncviewer -nocursorshape localhost::'+str(port)+' -passwd ~/'+filepassencnameuser+'" -u '+user
            self.shell_exec_remote(cmd)
        self.shell_exec_remote('-e "rm -rf '+filepassencname+'"')

    def access(self, users, passwd, remote = None):
        ips = self.poll_userlist(users)
        filename = os.path.expanduser('~/.gnome2/vinagre.bookmarks')
        bookmarksfile = open(filename,"w")
        for ip in ips:
            bookmarksfile.writelines('\n['+ip[1]+']\n')
            bookmarksfile.writelines('host='+ip[2]+'\n')
            bookmarksfile.writelines('port=5900\n')
        bookmarksfile.close()

        ip = " ".join([ip[2] for ip in ips])
        subprocess.Popen(['vinagre '+ip+' -s '+passwd] , shell=True, stdout=subprocess.PIPE)
        subprocess.Popen(['vinagre '+ip] , shell=True, stdout=subprocess.PIPE)

    def vncpasswd(self):
        return_text = ''
        cmd=['gksudo  "/usr/bin/ecm-remote -v"']
        return_shell = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
        return_text = return_shell.stdout.readlines()
        return_shell.wait()
        if not return_shell.returncode == 0 or return_text == []:
            return False
        return return_text[0]
